import java.util.Vector;

import processing.core.PApplet;

public class Animation {

	int[] nbFrames;// how many frames for each animation

	Animation(int[] nbFrames) {
		this.nbFrames = nbFrames;
	}

	public int[] getNbFrames() {
		return nbFrames;
	}

	public void setNbFrames(int[] nbFrames) {
		this.nbFrames = nbFrames;
	}

	public int getTotalFrames() {
		// returns the total number of frames
		// TODO
		int total = 0;
		for (int i = 0; i < nbFrames.length; i++) {
			if (nbFrames[i] > 0) {
				total += nbFrames[i];
			}
		}
		return total;
	}

	public String[] getSaveStrings() {
		Vector<String> result = new Vector<String>();
		result.add(PApplet.str(nbFrames.length));
		for (int i = 0; i < nbFrames.length; i++) {
			result.add(PApplet.str(nbFrames[i]));
		}
		String[] result2 = MyUtils.toStrArray(result);
		return result2;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		nbFrames = new int[Integer.parseInt(toLoad.remove(0))];
		for (int i = 0; i < nbFrames.length; i++) {
			nbFrames[i] = Integer.parseInt(toLoad.remove(0));
		}
		return toLoad;
	}
}
