import java.util.Vector;

public class MyUtils {

	static public float proxiCycle(float value, float from, float entire) {
		float distance = from - value;
		if (distance > entire / 2) {
			distance -= entire;
		}
		if (distance < -entire / 2) {
			distance += entire;
		}
		return distance;
	}

	public static Vector<String> addStringArray(Vector<String> result,
			String[] saveStrings) {
		for (int i = 0; i < saveStrings.length; i++) {
			result.add(saveStrings[i]);
		}
		return result;
	}

	public static String[] toStrArray(Vector<String> result) {
		String[] result2 = new String[result.size()];
		for (int i = 0; i < result.size(); i++) {
			result2[i] = result.get(i);
		}
		return result2;
	}

	public static String fileNameOf(String string) {
		int i = string.length() - 1;
		while (i > 0 && string.charAt(i) != 92) {
			i--;
		}
		return string.substring(i + 1, string.length() - 4);
	}

}
