import javax.swing.BorderFactory;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;

public class SwingMovement extends SwingWindow {
	private static final long serialVersionUID = 1L;

	Movement movement;

	JSlider type;
	JSlider amount;

	int divisions;

	SwingMovement(Rendering p, Movement movement) {
		super(p, movement);
	}

	protected void setTheContent(Object object) {
		divisions = 0xFF;
		movement = (Movement) object;
		type = new JSlider(1, 0, 3, 0);
		type.setBorder(BorderFactory.createTitledBorder("Type"));
		type.addChangeListener(this);
		b.add(type);
		amount = new JSlider(1, 0, divisions, divisions);
		amount.setBorder(BorderFactory.createTitledBorder("Amount"));
		amount.addChangeListener(this);
		b.add(amount);
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		if (!source.getValueIsAdjusting()) {
			if (source == type) {
				movement.setType(source.getValue());
			}
			if (source == amount) {
				movement.setAmount((float) source.getValue() / divisions);
			}
			parent.updateSheet();
		}
	}

}
