import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class SwingUnique extends SwingWindow implements ListSelectionListener {
	private static final long serialVersionUID = 1L;

	JList element;
	JButton scaling;
	JButton color;
	JButton outline;
	JButton movement;
	JSlider shape;
	JSlider number;
	JSlider variance;
	JSlider additionnal;
	JSlider additionnal2;
	JButton additionnal3;

	int divisions;

	private boolean SlidersListeners = true;

	SwingUnique(Rendering p) {
		super(p);
	}

	@Override
	protected void setTheContent(Object object) {
		divisions = 0xFF;
		String[] data = { "Spikes", "Feet", "Wings", "Tummy" };
		element = new JList(data);
		element.setBorder(BorderFactory.createTitledBorder("element"));
		element.addListSelectionListener(this);
		b.add(element);
		// test this by : element.getSelectedValue();
		scaling = new JButton("scaling");
		scaling.addActionListener(this);
		b.add(scaling);
		color = new JButton("color");
		color.addActionListener(this);
		b.add(color);
		outline = new JButton("outline");
		outline.addActionListener(this);
		b.add(outline);
		movement = new JButton("movement");
		movement.addActionListener(this);
		b.add(movement);
		shape = new JSlider(1, 0, divisions, 0);
		shape.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "shape"));
		shape.addChangeListener(this);
		b.add(shape);
		number = new JSlider(1, 0, divisions, 0);
		number.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "number"));
		number.addChangeListener(this);
		b.add(number);
		variance = new JSlider(1, 0, divisions, 0);
		variance.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "variance"));
		variance.addChangeListener(this);
		b.add(variance);
		additionnal = new JSlider(1, 0, divisions, 0);
		additionnal.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "additionnal"));
		additionnal.addChangeListener(this);
		b.add(additionnal);
		additionnal2 = new JSlider(1, 0, divisions, 0);
		additionnal2.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "additionnal2"));
		additionnal2.addChangeListener(this);
		b.add(additionnal2);
		additionnal3 = new JButton("additionnal 3");
		additionnal3.addActionListener(this);
		b.add(additionnal3);
	}

	public void stateChanged(ChangeEvent e) {
		if (SlidersListeners) {
			JSlider source = (JSlider) e.getSource();
			if (!source.getValueIsAdjusting()) {
				if (element.getSelectedValue() == "Spikes") {
					if (source == shape) {
						parent.sandBox.mainBody.constitution
								.getSpikes()
								.setShapeType(
										(int) ((float) source.getValue() * 4 / divisions));
					}
					if (source == number) {
						parent.sandBox.mainBody.constitution
								.getSpikes()
								.setNumber(
										(int) ((float) source.getValue() * 5 / divisions));
					}
					if (source == variance) {
						parent.sandBox.mainBody.constitution
								.getSpikes()
								.setVariance(
										(float) ((float) source.getValue() / divisions));
					}
					if (source == additionnal) {
						parent.sandBox.mainBody.constitution
								.getSpikes()
								.setDensity(
										(int) ((float) source.getValue() * 20 / divisions));
					}
				}
				if (element.getSelectedValue() == "Feet") {
					if (source == shape) {
						parent.sandBox.mainBody.constitution
								.getFeet()
								.setShapeType(
										(int) ((float) source.getValue() * 4 / divisions));
					}
					if (source == number) {
						parent.sandBox.mainBody.constitution
								.getFeet()
								.setNumber(
										(int) ((float) source.getValue() * 32 / divisions));
					}
					if (source == variance) {
						parent.sandBox.mainBody.constitution
								.getFeet()
								.setVariance(
										(float) ((float) source.getValue() / divisions));
					}
					if (source == additionnal) {
						parent.sandBox.mainBody.constitution
								.getFeet()
								.setConvergeance(
										(float) ((float) source.getValue() * 4 / divisions));
					}
					if (source == additionnal2) {
						parent.sandBox.mainBody.constitution
								.getFeet()
								.setBase(
										(float) ((float) source.getValue() / divisions));
					}
				}
				if (element.getSelectedValue() == "Wings") {
					if (source == shape) {
						parent.sandBox.mainBody.constitution
								.getWings()
								.setShapeType(
										(int) ((float) source.getValue() * 4 / divisions));
					}
					if (source == number) {
						parent.sandBox.mainBody.constitution
								.getWings()
								.setNumber(
										(int) ((float) source.getValue() * 8 / divisions));
					}
					if (source == variance) {
						parent.sandBox.mainBody.constitution
								.getWings()
								.setVariance(
										(float) ((float) source.getValue() / divisions));
					}
					if (source == additionnal) {
						parent.sandBox.mainBody.constitution
								.getWings()
								.setLargeur(
										(float) ((float) source.getValue() * 4 / divisions));
					}
					if (source == additionnal2) {
						parent.sandBox.mainBody.constitution
								.getWings()
								.setBase(
										(float) ((float) source.getValue() / divisions));
					}
				}
				if (element.getSelectedValue() == "Tummy") {
					if (source == shape) {
						parent.sandBox.mainBody.constitution
								.getTummy()
								.setShapeType(
										(int) ((float) source.getValue() * 4 / divisions));
					}
					if (source == number) {
						parent.sandBox.mainBody.constitution
								.getTummy()
								.setNumber(
										(int) ((float) source.getValue() * 2 / divisions));
					}
					if (source == variance) {
						parent.sandBox.mainBody.constitution
								.getTummy()
								.setVariance(
										(float) ((float) source.getValue() / divisions));
					}
					if (source == additionnal) {
						parent.sandBox.mainBody.constitution
								.getTummy()
								.setDivs(
										(int) ((float) source.getValue() * 0xFF / divisions));
					}
					if (source == additionnal2) {
						parent.sandBox.mainBody.constitution
								.getTummy()
								.setIrreg(
										(float) ((float) source.getValue() / divisions));
					}
				}
				parent.updateSheet();
			}
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (element.getSelectedValue() == "Spikes") {
			if (source == color) {
				new SwingColor(parent, parent.sandBox.mainBody.constitution
						.getSpikes().getColor());
			}
			if (source == scaling) {
				new SwingScaling(parent, parent.sandBox.mainBody.constitution
						.getSpikes().getScaling());
			}
			if (source == outline) {
				new SwingOutline(parent, parent.sandBox.mainBody.constitution
						.getSpikes().getOutline());
			}
			if (source == movement) {
				new SwingMovement(parent, parent.sandBox.mainBody.constitution
						.getSpikes().getMovement());
			}
			if (source == additionnal3) {
				parent.sandBox.mainBody.constitution.getSpikes()
						.switchComplete();
			}
		}
		if (element.getSelectedValue() == "Feet") {
			if (source == color) {
				new SwingColor(parent, parent.sandBox.mainBody.constitution
						.getFeet().getColor());
			}
			if (source == scaling) {
				new SwingScaling(parent, parent.sandBox.mainBody.constitution
						.getFeet().getScaling());
			}
			if (source == outline) {
				new SwingOutline(parent, parent.sandBox.mainBody.constitution
						.getFeet().getOutline());
			}
			if (source == movement) {
				new SwingMovement(parent, parent.sandBox.mainBody.constitution
						.getFeet().getMovement());
			}
		}
		if (element.getSelectedValue() == "Wings") {
			if (source == color) {
				new SwingColor(parent, parent.sandBox.mainBody.constitution
						.getWings().getColor());
			}
			if (source == scaling) {
				new SwingScaling(parent, parent.sandBox.mainBody.constitution
						.getWings().getScaling());
			}
			if (source == outline) {
				new SwingOutline(parent, parent.sandBox.mainBody.constitution
						.getWings().getOutline());
			}
			if (source == movement) {
				new SwingMovement(parent, parent.sandBox.mainBody.constitution
						.getWings().getMovement());
			}
		}
		if (element.getSelectedValue() == "Tummy") {
			if (source == color) {
				new SwingColor(parent, parent.sandBox.mainBody.constitution
						.getTummy().getColor());
			}
			if (source == scaling) {
				new SwingScaling(parent, parent.sandBox.mainBody.constitution
						.getTummy().getScaling());
			}
			if (source == outline) {
				new SwingOutline(parent, parent.sandBox.mainBody.constitution
						.getTummy().getOutline());
			}
			if (source == movement) {
				new SwingMovement(parent, parent.sandBox.mainBody.constitution
						.getTummy().getMovement());
			}
		}
	}

	@Override
	public void valueChanged(ListSelectionEvent e) {
		JList source = (JList) e.getSource();
		SlidersListeners = false;
		loadValuesOf(source.getSelectedIndex());
		SlidersListeners = true;
	}

	private void loadValuesOf(int selectedIndex) {
		if (selectedIndex == 0) {
			shape.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getSpikes().getShapeType() / 4 * divisions));
			number.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getSpikes().getNumber() / 5 * divisions));
			variance
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getSpikes().getVariance() * divisions));
			additionnal
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getSpikes().getDensity() / 20 * divisions));
			additionnal2.setValue((int) 0);
		}
		if (selectedIndex == 1) {
			shape.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getFeet().getShapeType()
					/ (float) 4 * (float) divisions));
			number.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getFeet().getNumber()
					/ (float) 32 * (float) divisions));
			variance
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getFeet().getVariance() * (float) divisions));
			additionnal
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getFeet().getConvergeance()
							/ (float) 4 * (float) divisions));
			additionnal2
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getFeet().getBase() / (float) divisions));
		}
		if (selectedIndex == 2) {
			shape.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getWings().getShapeType() / 4 * divisions));
			number.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getWings().getNumber() / 8 * divisions));
			variance
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getWings().getVariance() * divisions));
			additionnal
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getWings().getLargeur() / 4 * divisions));
			additionnal2
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getWings().getBase() / divisions));
		}
		if (selectedIndex == 3) {
			shape.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getTummy().getShapeType() / 4 * divisions));
			number.setValue((int) ((float) parent.sandBox.mainBody.constitution
					.getTummy().getNumber() / 2 * divisions));
			variance
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getTummy().getVariance() * divisions));
			additionnal
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getTummy().getDivs() / 0xFF * divisions));
			additionnal2
					.setValue((int) ((float) parent.sandBox.mainBody.constitution
							.getTummy().getIrreg() / divisions));
		}
	}
}
