import java.util.Vector;

import processing.core.PApplet;

public class Bound extends Limbs {

	Bound(PApplet p, Constitution constitution) {
		super(p);
		this.constitution = constitution;
		this.movement = new Movement();
	}

	public Constitution getConstitution() {
		return constitution;
	}

	public void setConstitution(Constitution constitution) {
		this.constitution = constitution;
	}

	public int getInstanceToAttach() {
		return instanceToAttach;
	}

	public void setInstanceToAttach(int instanceToAttach) {
		this.instanceToAttach = instanceToAttach;
	}

	public boolean isVisible() {
		return visible;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}

	public Movement getMovement() {
		return movement;
	}

	public void setMovement(Movement movement) {
		this.movement = movement;
	}

	Constitution constitution;
	int instanceToAttach;// negative numbers are unique limbs
	boolean visible;
	Movement movement;

	public void updateSharedColor() {
		// TODO
	}

	public void updateSharedOutline() {
		// TODO
	}

	public void randomSet() {
		super.randomSet();
		instanceToAttach = (int) (Math.random()
				* (constitution.getPLimbSize() + 4) - 4);
		if (Math.random() < 0.5) {
			visible = true;
		} else {
			visible = false;
		}
		movement.randomSet();
	}

	public String[] getSaveStrings() {
		Vector<String> result = new Vector<String>();
		result.add(PApplet.str(instanceToAttach));
		result.add(PApplet.str(visible));
		result = MyUtils.addStringArray(result, movement.getSaveStrings());
		String[] result2 = MyUtils.toStrArray(result);
		return result2;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		instanceToAttach = Integer.parseInt(toLoad.remove(0));
		visible = Boolean.parseBoolean(toLoad.remove(0));
		toLoad = movement.loadSaveStrings(toLoad);
		return toLoad;
	}

}
