import processing.core.PApplet;

public class SandBox {

	PApplet parent;

	MainBody mainBody;

	SandBox(PApplet p) {
		this.parent = p;
	}

	public void testSetup() {
		mainBody = new MainBody(parent);
		mainBody.spriteSheet.animation.setNbFrames(new int[] { 1, 0, 0, 0, 0,
				13, 12, 11 });
		// 0 : Still 1
		// 1 : Walker walking 24
		// 2 : Walker idling 36
		// 3 : Walker jumping 17
		// 4 : Fly flying 13
		// 5 : Jumper crouch 13
		// 6 : Jumper air 12
		// 7 : Jumper ground 11
		mainBody.updateSheet();
	}

	public void testDraw() {
		parent.background(0);
		parent.image(mainBody.displaySheet(), 0, 0);
		parent.image(mainBody.spriteSheet.displayGrid(), 0, 0);
	}

	public void keyPressed() {
		saveSheet("blah");
	}

	public void mousePressed() {
		updateSheet();
	}

	public void saveSheet(String name) {
		mainBody.saveSheet(name);
	}

	public void updateSheet() {
		mainBody.updateSheet();
	}

	public void extend() {
		mainBody.extendParameters();
	}

	public void randomMonster() {
		mainBody.randomMonster();
	}

}
