import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JSlider;

public class SwingBound extends SwingWindow {
	private static final long serialVersionUID = 1L;

	Bound bound;

	JSlider instanceToAttach;
	JCheckBox visible;
	JButton movement;

	SwingBound(Rendering p, Bound bound) {
		super(p, bound);
	}

	@Override
	protected void setTheContent(Object object) {
		bound = (Bound) object;
		instanceToAttach = new JSlider(1);
		instanceToAttach.setBorder(BorderFactory.createTitledBorder("To"));
		instanceToAttach.addChangeListener(this);
		b.add(instanceToAttach);
		visible = new JCheckBox("visible");
		visible.addChangeListener(this);
		b.add(visible);
		movement = new JButton("movement");
		movement.addActionListener(this);
		b.add(movement);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == movement) {
			new SwingMovement(parent, bound.getMovement());
		}
	}
}
