import java.awt.event.ActionEvent;

import javax.swing.JButton;

public class SwingSets extends SwingWindow {
	private static final long serialVersionUID = 1L;

	JButton random;
	int nbPresets;
	JButton[] preset;

	SwingSets(Rendering p) {
		super(p);
	}

	@Override
	protected void setTheContent(Object object) {
		random = new JButton("random");
		random.addActionListener(this);
		b.add(random);
		nbPresets = MainBody.getNbPresets();
		preset = new JButton[nbPresets];
		for (int i = 0; i < nbPresets; i++) {
			preset[i] = new JButton("Preset " + i);
			preset[i].addActionListener(this);
			b.add(preset[i]);
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == random) {
			parent.randomMonster();
		}
		for (int i = 0; i < nbPresets; i++) {
			if (source == preset[i]) {
				parent.sandBox.mainBody.loadPreset(i);
			}
		}
	}

}
